From 7ea1395c24147429400b4429dd45b850091dfab0 Mon Sep 17 00:00:00 2001
From: Pierre-Yves Chibon <pingou@pingoured.fr>
Date: Apr 14 2016 18:25:22 +0000
Subject: [PATCH 398/1001] Implement configuring widgets directly in the UI


---

diff --git a/hubs/app.py b/hubs/app.py
index c57cdb4..75c53ed 100755
--- a/hubs/app.py
+++ b/hubs/app.py
@@ -156,20 +156,47 @@ def widget_json(hub, idx):
 @app.route('/<hub>/<idx>/edit', methods=['GET'])
 def widget_edit_get(hub, idx):
     widget = get_widget(session, hub, idx)
-    raise NotImplementedError('next step is to get the widgets to render '
-                              'editable versions of themselves with their '
-                              'declared @arguments, etc...')
-    return widget.render(session, edit=True)
+    if not widget.module.data.widget_arguments:
+        flask.abort(404, 'Nothing to configure for this hub.')
+    return flask.render_template(
+        'edit.html',
+        hub=hub,
+        widget=widget,
+        url_to=flask.url_for('widget_edit_post', hub=hub, idx=idx)
+    )
 
 
 @app.route('/<hub>/<idx>/edit/', methods=['POST'])
 @app.route('/<hub>/<idx>/edit', methods=['POST'])
 def widget_edit_post(hub, idx):
-    #widget = get_widget(session, hub, idx)
-    # TODO -- save things to the db ... and then redirect
-    widget.hub.last_edited = datetime.datetime.utcnow()
-    raise NotImplementedError('TODO - save changes to widget config')
-    flask.redirect(flask.url_for('hub', name=hub))
+    widget = get_widget(session, hub, idx)
+    error = False
+    config = {}
+    for arg in widget.module.data.widget_arguments:
+        val = flask.request.form.get(arg.name)
+        if not val:
+            flask.flash(
+                'You must provide a value for: %s' % arg.name, 'error')
+            error = True
+            break
+        try:
+            arg.validator(session, val)
+            config[arg.name] = val
+        except Exception as err:
+            flask.flash('Invalid data provided, error: %s' % err, 'error')
+            error = True
+    if not error:
+        widget.config = config
+        widget.hub.last_edited = datetime.datetime.utcnow()
+        session.add(widget)
+        try:
+            session.commit()
+        except Exception as err:
+            flask.flash(
+                'Could not save the configuration to the database '\
+                'if the error persists, please warn an admin',
+                'error')
+    return flask.redirect(flask.url_for('hub', name=hub))
 
 
 @app.route('/source/<name>/')
